alphabet_writing <- function(label, file_name, random_file = "") {
	cat("writing the epigenomic ...\t", file_name,"\n");
	str = ""
	alphabet <- c()
	for (i in 1:length(label)) {
		if (i%%100==0) {
			alphabet <- c(alphabet, str)
			str = ""
		}
	str = paste(str, label[i], sep = "")
	}
	alphabet <- c(alphabet, str)

	if (random_file == "")
		sink(paste(file_name, ".dna", sep = ""))

	if (random_file != "")
		sink(paste(random_file, ".dna", sep = ""))
		
	cat(paste(">",substring(file_name,3,nchar(file_name)), sep = ""), "\n")
	#cat(paste(">",substring(file_name, nchar(file_name)-5, nchar(file_name)),sep=""), "\n")
	for (i in 1:length(alphabet))
		cat(alphabet[i], "\n")
	sink()
}


	Args <- commandArgs()
	k = 3
	times = 0
	folder = "."
	random = 0
	dict_file = ""

	for (i in 1:length(Args)) {
		if (Args[i] == "--f") file_name = Args[i+1]
		if (Args[i] == "--k") k = as.numeric(Args[i+1])
		if (Args[i] == "--d") dict_file = Args[i+1]
		if (Args[i] == "--r") random = as.numeric(Args[i+1])
		if (Args[i] == "--o") output_file = Args[i+1]
	}
	
	letter <- as.character(read.table(dict_file)[,1])
	
	cat("Processing file ", file_name, "with ", k, " epi-letters from the dictionary file epi_letter.dict\n")

	#if (k==5) {
	#	letter <- c("S", "H", "M", "I", "L", "N")
	#}
	
	#if (k==3) {
	#	letter <- c("H", "M", "L", "N")
	#}

	cat(file_name, "\n")
	temp_chr = unlist(strsplit(file_name, "/"))
	if (length(temp_chr)>1) {folder = temp_chr[1]}
	
	t <- read.csv(file_name, sep = "\t", header=F)
	colnames(t) <- as.character(unlist(t[1,]))
	t <- t[-c(1),]
	
	for (mark in 2:ncol(t)) {
		cat(colnames(t)[mark], "\n")
		kmean_file = paste(folder, paste(colnames(t)[mark], ".cutoff", sep = ""), sep = "/")
		mydata <- read.csv(kmean_file, sep = '\t', header = FALSE)
		cutoff <- c(mydata[1,3]+1)
		for (i in 1:k) { cutoff <- c(cutoff, mydata[i,2])}
		cutoff[length(cutoff)] = cutoff[length(cutoff)]-1

		t2 <- as.vector(t[,mark])
		label <- rep(0, times = length(t2))
		label[which(is.na(t2))] = k+1
		t2[which(is.na(t2))] = 1000
		for (i in 1:k) {label[which(as.numeric(t2)<=cutoff[i] & as.numeric(t2)>=cutoff[i+1])] <- i;}
		temp <- cbind(as.character(t[,1]), t2, label)
		colnames(temp) <- c("Coors", "Signals", "Label")
		write.table(temp, paste(colnames(t)[mark], ".dict", sep = ""), row.names=F, col.names=T, quote=F, sep = "\t")

		for (i in 1:(k+1)) {
			cat(letter[i], ":\t")
			label[which(label==i)] <- letter[i]
			cat(length(which(label==letter[i]))/length(label)*100, "\n")
		}

		alphabet_writing(label, paste(folder,colnames(t)[mark], sep = "/"))
		
		if (random != 0) {

			random_folder = paste(folder, paste(colnames(t)[mark], "_random", sep = ""), sep = "/")
			system(paste("mkdir", random_folder))
		
			for (i in 1:times) {
				#set.seed(i)
				ind <- sample(1:length(label))
				label2 <- label[ind]
				alphabet_writing(label2, file_name, paste(random_folder, as.character(i), sep = "/"))
			}
		}

}

write.table(temp[,1], paste(output_file, ".coor", sep = ""), sep = "\t", quote=F, row.names=F, col.names=F)

system(paste("cat *.dna", output_file, sep = " > "))
#system("mkdir dictionary")
#system(paste("mv *.dict dictionary"))
