#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<list>
#include<cstring>
#include<fstream>
#include<stdlib.h>
#include<sstream>
#include<unistd.h>

using namespace std;

const int MAXN = 500000;

long double A[MAXN];
int N, K;

void Input(string in_file){
    ifstream fin (in_file.c_str());	
	fin >> N >>K;
	
	for (int i=0; i<N; i++) {
		fin >> A[i];
	}
	
    fin.close();
}

void quicksort(long double *a, int *index, int lower,int upper)
{
    int split(long double*, int*, int,int),pivot;
    if(upper>lower)
	{
		pivot=split(a, index, lower, upper);
		quicksort(a, index, lower,pivot-1);
		quicksort(a, index, pivot+1,upper);
		
	}
}

int split(long double *a, int *index, int lower,int upper)
{
    int p,q; long double i;
    p=lower+1;
    q=upper;
    i=a[lower];
    while(q>=p)
	{
		while(a[p]<i)
			p++;
		while(a[q]>i)
			q--;
		if(q>p)
		{
			long double t=a[p];
			a[p]=a[q];
			a[q]=t;
			int _t = index[p];
			index[p] = index[q];
			index[q] = _t;
		}
	}
    long double t=a[lower];
    a[lower]=a[q];
    a[q]=t;
    int _t=index[lower];
    index[lower]=index[q];
    index[q]=_t;
    return q;
}

long double mean_sum(int l, int r, long double *sumA, long double *sumAsquare) {
	long double mean = (sumA[r]-sumA[l-1])/(r-l+1);
	return sumAsquare[r]-sumAsquare[l-1]- 2*(sumA[r]- sumA[l-1])*mean + mean*mean*(r-l+1);
}

// Runs k-means on the given set of points.
//   - n: The number of points in the data set
//   - k: The number of clusters to look for
//   - d: The number of dimensions that the data set lives in
//   - points: An array of size n*d where points[d*i + j] gives coordinate j of poi
//   - attempts: The number of times to independently run k-means with different starting centers.
//               The best result is always returned (as measured by the cost function).
//   - centers: This can either be null or an array of size k*d. In the latter case, it will be
//              filled with the locations of all final cluster centers. Specifically
//              centers[d*i + j] will give coordinate j of center i. If the cluster is unused, it
//              will contain NaN instead.
//   - assignments: This can either be null or an array of size n. In the latter case, it will be
//                  filled with the cluster that each pois assigned to (an integer between 0
//                  and k-1 inclusive).
// The final cost of the clustering is also returned.

long double RunKMeans1D(int n, int k, long double *points, long double *centers, int *assignments) {
	long double *sumA;
	long double *sumAsquare;
	long double **Cost;
	int **trace;
	
	sumA = new long double[n+1];
	sumAsquare = new long double[n+1];
	Cost = new long double*[n+1];
	for (int i=0; i<=n; i++) Cost[i] = new long double[k+1];
	trace = new int*[n+1];
	for (int i=0; i<=n; i++) trace[i] = new int[k+1];

	int *index = new int[n+1];
	for (int i=0; i<n; i++) index[i] = i;

	//for (int i=1; i<=n; i++) cout <<index[i] <<"\t" <<points[i] <<endl;

	//quicksort(points, index, 0, n-1);
	
	//for (int i=n; i>0; i--) {points[i] = points[i-1]; index[i] = index[i-1];}
	//for (int i=1; i<=n; i++) cout <<index[i] <<"\t" <<points[i] <<endl;
	
	//exit(1);
	
	sumA[0] = 0; sumAsquare[0] =0;
	for (int i=1; i<=n; i++) {
		sumA[i] = sumA[i-1] + points[i-1];
		sumAsquare[i] = sumAsquare[i-1] + points[i-1]*points[i-1];
	}
	
	Cost[0][0] = 0;
	for (int i=1; i<=n; i++) {
		Cost[i][1] = mean_sum(1, i, sumA, sumAsquare);
		trace[i][1] = 0;
		for (int j=2; j<=(i<=k?i:k); j++) {
			Cost[i][j] = Cost[j-1][j-1]+ mean_sum(j, i, sumA, sumAsquare);
			trace[i][j] = j-1;
			for (int _k=j; _k<=i-1; _k++) {
				long double temp = mean_sum(_k+1, i, sumA, sumAsquare);
				if (Cost[i][j] >= Cost[_k][j-1]+ temp) {
					Cost[i][j] = Cost[_k][j-1]+ temp;			
					trace[i][j] = _k;
				}
			}
		}
	}
	
	// printing the cost from k = 1..10
	//for (int i=10; i>=1; i--) {
	//	cout << Cost[n][i] <<endl;
	//}
	//exit(1);
	
	//cout << Cost[n][k] <<endl;
	
    int i = n; int j = k;
    while (i>0) {
		int t= trace[i][j];
		centers[k-j] = (sumA[i]-sumA[t])/(i-t);
		cout << "category " <<k-j<<endl;
		for (int _i=t+1; _i<=i; _i++) {
			//cout <<index[_i] << "\t" <<points[_i] <<endl;
			assignments[index[_i-1]] = k-j; //points[_i] \in category k-j
		}
		i=t; j=j-1;
	}
	
	for (int i=n; i>=0; i--) delete [] Cost[i];
	delete [] Cost;
	for (int i=n; i>=0; i--) delete [] trace[i];
	delete [] trace;
	
	delete [] sumA;
	delete [] sumAsquare;
}
     
int main (int argc, char **argv) {
	string in_file, out_file;
	char c;
	while (1) {
		c = getopt (argc, argv, "f:h:o:");
		if (c == -1)break;
		switch (c) {
			case 'f': in_file = optarg; break;
			case 'o': out_file = optarg; break;
		}
	}
	
	Input(in_file);
	long double *centers = new long double[K+1];
	int *assignments = new int[N+1];
	
	long double *A_temp = new long double[N+1]; memcpy(A_temp, A, sizeof(long double)*(N+1));
	
	cout << in_file.c_str() <<endl;

	cout << "start grouping ...\n";

	RunKMeans1D(N, K, A, centers, assignments);
	
	cout<<"done.\n";

	freopen(out_file.c_str(),"w",stdout);

	for (int k=0; k<K; k++) {
		//cout <<"category " <<k<< ":"<<centers[k] <<endl;
		//int count = 0;
		long double max_cutoff=-999999999, min_cutoff=999999999;
		for (int i=0; i<N; i++) 
			if (assignments[i] == k ) {//count++;
				if (A_temp[i]>max_cutoff) {max_cutoff=A_temp[i];}
				if (A_temp[i]<min_cutoff) {min_cutoff=A_temp[i];}
				//cout <<count<<endl;
				//cout.precision(15);
				//cout <<assignments[i] << "\t" << fixed <<A_temp[i] <<endl;
			}
		cout << k+1 <<"\t";
		cout.precision(15);
		cout <<fixed <<min_cutoff <<"\t" <<max_cutoff <<endl;
	}
	
	return 0;
}
