	Args <- commandArgs()
	k = 4
	file_name = ""
	file_name2 = ""
	file_name3= ""

	for (i in 1:length(Args)) {
		if (Args[i] == "--f") file_name = Args[i+1]		# hamming distance file
		if (Args[i] == "--u") file_name2 = Args[i+1]	# unique pattern file
		if (Args[i] == "--c") file_name3 = Args[i+1]	#original pattern file
		if (Args[i] == "--k") k = as.numeric(Args[i+1])	
	}
	
dist_matrix <- read.table(file_name, header=F)

t <- read.table(file_name2)
motifs <- as.character(t[,1])

rownames(dist_matrix) = colnames(dist_matrix) = motifs

d <- as.dist(dist_matrix)

mycl4 <- kmeans(d, k,100)

mycl <- mycl4$cluster
n_clusters = length(unique(mycl))

t <- read.table(file_name3)
clust2 <- lapply(1:nrow(t), function(x) mycl[which(names(mycl)==as.character(t[x,3]))])
clust2 <- unlist(clust2)
t2 <- cbind(t, clust2)
t2 <- t2[,-2]

for (clust_id in 1:k) {
	temp <- subset(t2, t2[,3]==clust_id)
	colnames(temp) <- c("Coor", "Pattern", "Cluster")
	write.table(temp, paste("cluster_", clust_id, sep = ""), quote=F, sep = "\t", row.names=F, col.names=F)
	write.table(temp[,2], paste("cluster_", paste(clust_id, ".logo", sep = ""), sep = ""), quote=F, sep = "\t", row.names=F, col.names=F)
}